"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_native_1 = require("react-native");
const react_1 = __importDefault(require("react"));
const styles = react_native_1.StyleSheet.create({
    alignContentFlexStart: {
        alignContent: 'flex-start',
    },
    alignContentFlexEnd: {
        alignContent: 'flex-end',
    },
    alignContentCenter: {
        alignContent: 'center',
    },
    alignContentStretch: {
        alignContent: 'stretch',
    },
    alignContentSpaceBetween: {
        alignContent: 'space-between',
    },
    alignContentSpaceAround: {
        alignContent: 'space-around',
    },
    alignItemsFlexStart: {
        alignItems: 'flex-start',
    },
    alignItemsFlexEnd: {
        alignItems: 'flex-end',
    },
    alignItemsCenter: {
        alignItems: 'center',
    },
    alignItemsStretch: {
        alignItems: 'stretch',
    },
    alignItemsBaseline: {
        alignItems: 'baseline',
    },
    alignSelfAuto: {
        alignSelf: 'auto',
    },
    alignSelfFlexStart: {
        alignSelf: 'flex-start',
    },
    alignSelfFlexEnd: {
        alignSelf: 'flex-end',
    },
    alignSelfCenter: {
        alignSelf: 'center',
    },
    alignSelfStretch: {
        alignSelf: 'stretch',
    },
    alignSelfBaseline: {
        alignSelf: 'baseline',
    },
    directionRow: {
        flexDirection: 'row',
    },
    directionRowReverse: {
        flexDirection: 'row-reverse',
    },
    directionColumn: {
        flexDirection: 'column',
    },
    directionColumnReverse: {
        flexDirection: 'column-reverse',
    },
    noGrow: {
        flexGrow: 0,
    },
    noShrink: {
        flexShrink: 0,
    },
    wrap: {
        flexWrap: 'wrap',
    },
    noWrap: {
        flexWrap: 'nowrap',
    },
    justifyContentFlexStart: {
        justifyContent: 'flex-start',
    },
    justifyContentFlexEnd: {
        justifyContent: 'flex-end',
    },
    justifyContentCenter: {
        justifyContent: 'center',
    },
    justifyContentSpaceBetween: {
        justifyContent: 'space-between',
    },
    justifyContentSpaceAround: {
        justifyContent: 'space-around',
    },
    justifyContentSpaceEvenly: {
        justifyContent: 'space-evenly',
    },
    alignCenter: {
        justifyContent: 'center',
        alignItems: 'center',
    },
});
const FlexBox = (props) => {
    const filterStyle = [];
    const other = { children: props.children };
    Object.keys(props).forEach(k => {
        if (k in styles) {
            filterStyle.push(styles[k]);
        }
        else {
            other[k] = props[k];
        }
    });
    const { style: propsStyle, children, flex, basis, alignHCenter, alignVCenter, alignCenter, ...rest } = other;
    const compStyle = {};
    flex && (compStyle.flex = flex);
    basis && (compStyle.flexBasis = basis);
    if (alignHCenter || alignCenter) {
        switch (true) {
            case props.directionRow:
            case props.directionRowReverse:
                compStyle.justifyContent = 'center';
                break;
            case props.directionColumn:
            case props.directionColumnReverse:
            default:
                compStyle.alignItems = 'center';
                break;
        }
    }
    if (alignVCenter || alignCenter) {
        switch (true) {
            case props.directionRow:
            case props.directionRowReverse:
                compStyle.alignItems = 'center';
                break;
            case props.directionColumn:
            case props.directionColumnReverse:
            default:
                compStyle.justifyContent = 'center';
                break;
        }
    }
    return react_1.default.createElement(react_native_1.View, Object.assign({ style: [...filterStyle, compStyle, propsStyle] }, rest), children);
};
exports.default = FlexBox;
//# sourceMappingURL=index.js.map